/* Industrial io test prog
 *
 * Copyright (c) 2008 Jonathan Cameron
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * Little tool to poke character devices etc and see what events are coming out.
 */
#include <linux/types.h>
/* ought to be in a userspace header */
struct industrialio_output_event {
	int id;
	__u64 timestamp;
};

#include <stdio.h>
int main(int argc, char** argv)
{
	FILE *fp, *sysfsfp;
	unsigned char buf[100];
	size_t read_size;
	int i;
	int minor;
	char name[100];
	char command[100];
	struct industrialio_output_event ev;
	sysfsfp = fopen("/sys/class/industrialio/industrialio0/device/event_line0_minor", "r");
	fscanf(sysfsfp,"%d\n", &i);
	sprintf(name, "/dev/ind%d", minor);
	fp = fopen(name, "rb");
	if (fp == NULL) {
		sprintf(command, "mknod /dev/ind%d c 244 %d", minor, minor);
		system(command);
		fp = fopen(name, "rb");
		if(fp == NULL) {
			printf("Unable to open %s\n", argv[1]);
			return -1;
		}
	}
	sleep(10);
	for(i=0; i< 100; i++) {
	  printf("trying to do a read \n");
	  read_size = fread(&ev, 1, sizeof(struct industrialio_output_event), fp);
		
		//first 4 bytes are an int.
	  printf("Recieved event code %d, %llu\n", read_size, ev.timestamp);
	}
	return 0;

}

