/* Industrialio test ring buffer with a max1238
 *
 * Copyright (c) 2008 Jonathan Cameron
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * Little tool to poke character devices associated with ring buffer and see
 * what events are coming out.
 *
 * Todo: Make this more adapatable - e.g. allow specification of which
 *       ring to poke.
 *
 * Clearly this needs a lot of work if it going to be a coherent / general
 * piece of example code.
 */

#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <stdint.h>
#include <linux/types.h>


struct iio_event_data {
	int id;
	__s64 timestamp;
};
int main(int argc, char **argv)
{
	FILE  *sysfsfp, *fp_ev;
	int fp;
	char data[20000];
	size_t read_size;
	int i, j, k;
	int minor, minor_ev;
	char name[100];
	char name2[100];
	char command[100];
	char temp[100];
	int pos;
	struct iio_event_data dat;
	int device_no;

	if (argc == 1)
		return -1;
	device_no = atoi(argv[1]);
	pos = sprintf(temp, "/sys/class/industrialio/industrialio%d/device/",
		      device_no);
	sprintf(temp + pos, "ring_buffer0_access_minor");
	sysfsfp = fopen(temp, "r");
	if (sysfsfp == NULL) {
		printf("failed to open minor stuff \n");
		return -1;
	}

	fscanf(sysfsfp, "%d\n", &minor);
	sprintf(name, "/dev/indring%d", minor);

	fclose(sysfsfp);
	sprintf(temp + pos, "ring_buffer0_ev_minor");
	sysfsfp = fopen(temp, "r");
	if (sysfsfp == NULL) {
		printf("failed to open minor stuff \n");
		return -1;
	}

	fscanf(sysfsfp, "%d\n", &minor_ev);
	fclose(sysfsfp);
	sprintf(name2, "/dev/indringev%d", minor_ev);

	fp = open(name, O_RDONLY | O_NONBLOCK);
	if (fp == -1) {
		sprintf(command, "mknod %s c 244 %d; mknod %s c 244 %d ",
			name, minor, name2, minor_ev);
		system(command);
		fp = open(name, O_RDONLY | O_NONBLOCK);
		if (fp == -1) {
			printf("Unable to open %s\n", name);
			return -1;
		}
	}
	fp_ev = fopen(name2, "rb");
	if (fp_ev == NULL)
		printf("bug opening %s\n", name2);
	/* Wait for events 10 times */
	for (j = 0; j < 10; j++) {
		read_size = fread(&dat, 1, sizeof(struct iio_event_data),
				  fp_ev);
		printf("event code received: %d\n", dat.id);
		read_size = read(fp, (char *)(data), 100*(12+8));
		if (read_size == -EAGAIN)
			printf("nothing available \n");

		/* print a small amount of data */
		for (i = 0; i < 10; i++) {
			for (k = 0; k < 12; k++)
				printf("%d ",
				       ((int)((data[i*32 + (k)*2 + 0]
					       & 0x0F) << 8)
					+ ((int)((data[i*32 + (k)*2 + 1])))));
			printf(" %lld\n", *(__s64 *)(&data[i*32 + 12*2]));
		}
	}
	return 0;
}
