/* Industrialio test ring buffer
 *
 * Copyright (c) 2008 Jonathan Cameron
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * Little tool to poke character devices associated with ring buffer and see
 * what events are coming out.
 *
 * Todo: Make this more adapatable - e.g. allow specification of which
 *       ring to poke.
 */

#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <stdint.h>
#include <linux/types.h>
#include <linux/industrialio/sca3000.h>
struct industrialio_event_data {
	int id;
	__s64 timestamp;
};

union lis3l02dq_channel {
	char data[2];
	int16_t val;
};

struct lis3l02dq_datum {
	union lis3l02dq_channel el[3];
	__s64 time;
};

int main(int argc, char** argv)
{
	uint16_t tempx, tempy, tempz;
	FILE  *sysfsfp, *fp_ev, *bitsfile;
	int fp;
	char data[64*3*2];
	size_t read_size;
	int i ,j, k;
	int minor, minor_ev;
	char name[100];
	char name2[100];
	char command[100];
	struct industrialio_event_data dat;
	int bits;
	bitsfile = fopen("/sys/class/industrialio/industrialio0/device/ring_bps", "r");
	if (bitsfile == NULL) {
		printf("failed to open bits file \n");
	}
	fscanf(bitsfile, "%d\n", &bits);
	printf("bits per element of ring %d\n", bits);

	sysfsfp = fopen("/sys/class/industrialio/industrialio0/device/ring_buffer0_access_minor", "r");
	if (sysfsfp==NULL) {
	  printf("failed to open minor stuff \n");
	}

	fscanf(sysfsfp,"%d\n", &minor);
	sprintf(name, "/dev/indring%d", minor);

	fclose(sysfsfp);

	sysfsfp = fopen("/sys/class/industrialio/industrialio0/device/ring_buffer0_ev_minor", "r");
	if (sysfsfp==NULL) {
	  printf("failed to open minor stuff \n");
	}

	fscanf(sysfsfp, "%d\n", &minor_ev);
	fclose(sysfsfp);
	sprintf(name2, "/dev/indringev%d", minor_ev);

	fp = open(name, O_RDONLY | O_NONBLOCK);
	//fcntl(fp, F_SETFL, O_NONBLOCK);
	if (fp == -1) {
		printf("b\n");
		sprintf(command, "mknod %s c 244 %d; mknod %s c 244 %d ", name, minor, name2, minor_ev);
		system(command);
		printf("wtf? \n");
		fp = open(name, O_RDONLY | O_NONBLOCK);
		printf("oops\n");
		if(fp == -1) {
			printf("Unable to open %s\n", name);
			return -1;
		}
	}
	fp_ev = fopen(name2,"rb");
	if(fp_ev==NULL)
		printf("bug opening %s\n",name2);

	sleep(1);
	for(j = 0; j < 10; j++)
	{
		read_size = fread(&dat, 1, sizeof(struct industrialio_event_data), fp_ev);
		printf("event code received: %d\n", dat.id);
		if (bits == 11)
			read_size = read(fp,data, 32*3*2);
		else
			read_size = read(fp, data, 32*3);
		if(read_size == -EAGAIN)
			printf("nothing available \n");
		printf("Number recieved is %d vs requested %d \n", read_size, 32*3*2);
		for(i = 0; i < 10; i++) {
			for(k = 0; k < 3; k++)
				if(bits == 11)
					printf("%d ", sca3000_11bit_convert(data[(i*3+k)*2], data[(i*3+k)*2+1]));
				else if (bits == 8)
					printf("%d ", (int)(data[i*3+k]));
			printf("\n");
		}
	}


	return 0;

}

