/*
 *  linux/include/asm-arm/arch-pxa/stargate2.h
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef ASM_ARCH_STARGATE2_H
#define ASM_ARCH_STARGATE2_H

/* SG2 Platform Version */
#define SG2_PLATFORM_VERSION_95   95
#define SG2_PLATFORM_VERSION_97   97
#define SG2_PLATFORM_VERSION_101 101
#define SG2_PLATFORM_VERSION_102 102

/* USB client - debug UART switch */
#define SG2_USB_CLIENT_DEBUG_UART_SWITCH 115

/* Bluetooth */
#define SG2_GPIO81_BT_RESET MFP_CFG_OUT(GPIO81, AF0, DRIVE_LOW)
#define SG2_BT_RESET 81

// SD
#define SG2_GPIO90_nSD_DETECT GPIO90_GPIO
#define SG2_GPIO_nSD_DETECT     (90)
//Is there an irq_mfd function?
#define SG2_IRQ_GPIO_nSD_DETECT IRQ_GPIO(90)
#define SG2_SD_POWER_ENABLE 89

// PCMCIA
#define SG2_GPIO120_S0_BUFF_CTL MFP_CFG_OUT(GPIO120, AF0, DRIVE_LOW)
#define SG2_S0_BUFF_CTL 120
#define SG2_GPIO108_S0_POWER_CTL MFP_CFG_OUT(GPIO108, AF0, DRIVE_HIGH) 
#define SG2_S0_POWER_CTL 108
#define SG2_GPIO82_S0_RESET MFP_CFG_OUT(GPIO82, AF0, DRIVE_HIGH)
#define SG2_S0_RESET 82
#define SG2_S0_GPIO_DETECT 53
#define SG2_S0_GPIO_READY  81

#define SG2_S0_CD_IRQ      IRQ_GPIO(SG2_S0_GPIO_DETECT)   // card detect
#define SG2_S0_IRQ         IRQ_GPIO(SG2_S0_GPIO_READY)    // ready

// CC2420 Radio
// in mfp table?
#define SG2_GPIO34_SSPSCLK  (34 | GPIO_ALT_FN_3_OUT)   // SCLK
#define SG2_GPIO35_SSPTXD   (35 | GPIO_ALT_FN_3_OUT)   // SI
//#define SG2_GPIO39_SSPSFRM  (39 | GPIO_ALT_FN_3_OUT)   // CSn
#define SG2_GPIO41_SSPRXD   (41 | GPIO_ALT_FN_3_IN)    // SO
#define SG2_GPIO39_CC_SFRM  39
//#define SG2_GPIO39_CC_SFRM  (39 | GPIO_ALT_FN_3_OUT)   // CSn //why not this line?
#define SG2_GPIO22_CC_RSTN  22
#define SG2_GPIO114_CC_FIFO 114
#define IM2_GPIO115_CC_VREG 115
#define SG2_GPIO116_CC_CCA  116
#define SG2_GPIO0_CC_FIFOP  0
#define SG2_GPIO16_CC_SFD   16
#define CC2420_FIFO_IRQ     IRQ_GPIO(SG2_GPIO114_CC_FIFO)
#define CC2420_CCA_IRQ      IRQ_GPIO(SG2_GPIO116_CC_CCA)
#define CC2420_FIFOP_IRQ    IRQ_GPIO(SG2_GPIO0_CC_FIFOP)
#define CC2420_SFD_IRQ      IRQ_GPIO(SG2_GPIO16_CC_SFD)

/* should be in the realms of platform data */
#define CC2420_OST_IRQ  IRQ_OST_4_11

#define SG2_PCMCIA_VIRT 0xf0000000
#define SG2_PCMCIA_PHYS 0x20000000
#define SG2_P2V(x)		((x) - SG2_PCMCIA_PHYS + SG2_PCMCIA_VIRT)
#define SG2_V2P(x)		((x) - SG2_PCMCIA_VIRT + SG2_PCMCIA_PHYS)
#define __SG2_REG(x)		SG2_P2V(x)
#define SG2_PCMCIA0		__SG2_REG(0x080000e0)

#define SG2_PCMCIA_nSTSCHG_BVD1	(1 << 8)   /* VDD sense / card status changed */

// runtime board version check
int is_stargate2(void);

#endif
