
#include <linux/industrialio/sysfs.h>

#define IIO_DEV_ATTR_GYRO_X_OFFSET(_mode, _show, _store, _addr)	\
  IIO_DEVICE_ATTR(gyro_x_offset, _mode, _show, _store, _addr)

#define IIO_DEV_ATTR_GYRO_Y_OFFSET(_mode, _show, _store, _addr)	\
  IIO_DEVICE_ATTR(gyro_y_offset, _mode, _show, _store, _addr)

#define IIO_DEV_ATTR_GYRO_Z_OFFSET(_mode, _show, _store, _addr)	\
  IIO_DEVICE_ATTR(gyro_z_offset, _mode, _show, _store, _addr)

#define IIO_DEV_ATTR_GYRO_X(_show, _addr)			\
	IIO_DEVICE_ATTR(gyro_x, S_IRUGO, _show, NULL, _addr)

#define IIO_DEV_ATTR_GYRO_Y(_show, _addr)			\
	IIO_DEVICE_ATTR(gyro_y, S_IRUGO, _show, NULL, _addr)

#define IIO_DEV_ATTR_GYRO_Z(_show, _addr)			\
	IIO_DEVICE_ATTR(gyro_z, S_IRUGO, _show, NULL, _addr)

#define IIO_DEV_ATTR_GYRO_RANGE(_mode, _show, _store)	\
	IIO_DEVICE_ATTR(gyro_range, _mode, _show, _store, 0)

#define IIO_CONST_ATTR_GYRO_RANGE_AVAILABLE(_string)	\
	IIO_CONST_ATTR(gyro_range_available, _string)


#define IIO_EVENT_ATTR_GYRO_X_HIGH_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_x_high, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_X_HIGH IIO_EVENT_CODE_GYRO_BASE

#define IIO_EVENT_ATTR_GYRO_Y_HIGH_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_y_high, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Y_HIGH IIO_EVENT_CODE_GYRO_BASE + 1

#define IIO_EVENT_ATTR_GYRO_Z_HIGH_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_z_high, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Z_HIGH IIO_EVENT_CODE_GYRO_BASE + 2

#define IIO_EVENT_ATTR_GYRO_X_LOW_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_x_low, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_X_LOW IIO_EVENT_CODE_GYRO_BASE + 3

#define IIO_EVENT_ATTR_GYRO_Y_LOW_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_y_low, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Y_LOW IIO_EVENT_CODE_GYRO_BASE + 4

#define IIO_EVENT_ATTR_GYRO_Z_LOW_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_z_low, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Z_LOW IIO_EVENT_CODE_GYRO_BASE + 5

#define IIO_EVENT_ATTR_GYRO_X_ROC_HIGH_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_x_roc_high, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_X_ROC_HIGH IIO_EVENT_CODE_GYRO_BASE + 10

#define IIO_EVENT_ATTR_GYRO_X_ROC_LOW_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_x_roc_low, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_X_ROC_LOW IIO_EVENT_CODE_GYRO_BASE + 11

#define IIO_EVENT_ATTR_GYRO_Y_ROC_HIGH_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_y_roc_high, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Y_ROC_HIGH IIO_EVENT_CODE_GYRO_BASE + 12

#define IIO_EVENT_ATTR_GYRO_Y_ROC_LOW_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_y_roc_low, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Y_ROC_LOW IIO_EVENT_CODE_GYRO_BASE + 13

#define IIO_EVENT_ATTR_GYRO_Z_ROC_HIGH_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_z_roc_high, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Z_ROC_HIGH IIO_EVENT_CODE_GYRO_BASE + 14

#define IIO_EVENT_ATTR_GYRO_Z_ROC_LOW_SH(_evlist, _show, _store, _mask)	\
	IIO_EVENT_ATTR_SH(gyro_z_roc_low, _evlist, _show, _store, _mask)

#define IIO_EVENT_CODE_GYRO_Z_ROC_LOW IIO_EVENT_CODE_GYRO_BASE + 15
