#ifdef CONFIG_IIO_TIMERS
#include <linux/industrialio/industrialio_trigger.h>

/**
 * struct iio_periodic - for now this is the only type of periodic timer used
 * @rtc:		associated real time clock device
 * @frequency:		current interrupt frequency
 * @task:		task run on periodic interrupt
 */
#include <linux/rtc.h>


__deprecated struct iio_periodic {
  //	struct iio_trigger_source ts;

	struct rtc_device *rtc;
	int frequency;
	struct rtc_task task;
};

int iio_rtc_init(void);
/* Going to need a suite of access and control functions - as registered by different timers */
int iio_ptimer_request_periodic_timer(char *name, struct iio_dev *indio_dev);
void iio_ptimer_unrequest_periodic_timer(struct iio_dev *indio_dev);

int iio_ptimer_set_freq(struct iio_periodic *ptimer, unsigned frequency);
int iio_ptimer_irq_set_state(struct iio_dev *indio_dev, bool state);

/* Board registration is handled by contents of
 * industrialio_ptimer_board_info.c
 */


extern struct mutex industrialio_ptimer_board_lock;
extern struct list_head industrialio_ptimer_board_info_list;
#else /* CONFIG_IIO_TIMERS */
struct iio_periodic{};
static inline int iio_ptimer_request_periodic_timer(char *name, struct iio_dev *indio_dev)
{
	return 0;
};
static inline void iio_ptimer_unrequest_periodic_timer(struct iio_dev *indio_dev)
{};

static inline int iio_ptimer_set_freq(struct iio_periodic *ptimer, unsigned frequency)
{
	return 0;
};

static inline int iio_ptimer_irq_set_state(struct iio_dev *indio_dev, bool state)
{
	return 0;
};

static inline int iio_rtc_init()
{
	return 0;
};

#endif /* CONFIG_IIO_TIMERS */
