#ifndef __SHT15_H
#define __SHT15_H

#include <linux/kdev_t.h> /* for device nodes */
#include <linux/fs.h>
#include <linux/cdev.h>
#include <linux/gpio.h>

#define FALSE 0
#define TRUE 1

#define SUCCESS 0
#define FAIL -1

// gpio pin definitions
//#define SHT15_DATA 100
//#define SHT15_SCK 98

// device node
#define SHT15_MAJOR 0 //set to 0 to use dynamic allocation
#define SHT15_TEMP_MINOR 0
#define SHT15_RH_MINOR 1

#define SHT15_SENSOR_COUNT 2

// Commands
#define SHT15_CMD_NULL 0
#define SHT15_MEASURE_TEMP 3
#define SHT15_MEASURE_RH 5
#define SHT15_READ_STATUS 7
#define SHT15_WRITE_STATUS 6
#define SHT15_SOFT_RESET 30

struct sht15_platform_data  
{
  int gpio_data;
  int gpio_sck;
};

// struct for state
typedef struct _sht15_state
{
  wait_queue_head_t sht15_wait_queue;
  int busy;
  struct file_operations *fops;
  dev_t devno;
  struct cdev dev;
  uint8_t cmd;
  int flag;
  uint16_t reading;
  struct sht15_platform_data* pdata;
} sht15_state, *p_sht15_state;


#endif // __SHT15_H
