/*
 * ak4642.h  --  AK4642 ALSA Soc Audio driver
 *
 * Copyright 2008 University of Washington CSE
 *
 * Author: Brian Mayton <bmayton@cs.washington.edu>
 *
 * Based on AK4535.h by Richard Purdie
 * Based on wm8753.h by Liam Girdwood
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef _AK4642_H
#define _AK4642_H

/* AK4642 register space */

#define AK4642_PM1		0x0
#define AK4642_PM2		0x1
#define AK4642_SIG1		0x2
#define AK4642_SIG2		0x3
#define AK4642_MODE1	0x4
#define AK4642_MODE2	0x5
#define AK4642_TIMER	0x6
#define AK4642_ALC1		0x7
#define AK4642_ALC2		0x8
#define AK4642_LVOL_IN  0x09
#define AK4642_LVOL_OUT 0x0A
#define AK4642_ALC3     0x0B
#define AK4642_RVOL_IN  0x0C
#define AK4642_RVOL_OUT 0x0D
#define AK4642_MODE3    0x0E
#define AK4642_MODE4    0x0F
#define AK4642_PM3      0x10

// PM1 Bit definitions

#define PMADL 0
#define PMDAC 2
#define PMLO 3
#define PMSPK 4
#define PMBP 5
#define PMVCM 6

// PM2 Bit definitions

#define PMPLL 0
#define MCKO 1
#define MS 3
#define PMHPR 4
#define PMHPL 5
#define HPMTN 6

// SIG1 Bit definitions

#define MGAIN0 0
#define PMMP 2
#define DACL 4
#define DACS 5
#define BEEPS 6
#define SPPSN 7


#define AK4642_CACHEREGNUM 	0x20

struct ak4642_setup_data {
	unsigned short i2c_address;
};

extern struct snd_soc_dai ak4642_dai;
extern struct snd_soc_codec_device soc_codec_dev_ak4642;

#endif
